'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _BaseState2 = require('./BaseState');

var _BaseState3 = _interopRequireDefault(_BaseState2);

require('./Equatable');

var _Serializable = require('./Serializable');

var _common = require('./common');

var _common2 = _interopRequireDefault(_common);

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Account = function (_BaseState) {
  (0, _inherits3.default)(Account, _BaseState);

  function Account({
    version,
    hash,
    isFrozen,
    votes,
    balances
  }) {
    (0, _classCallCheck3.default)(this, Account);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Account.__proto__ || (0, _getPrototypeOf2.default)(Account)).call(this, { version }));

    _this.equals = _utils2.default.equals(Account, other => _common2.default.uInt160Equal(_this.hash, other.hash));
    _this.serializeWire = (0, _Serializable.createSerializeWire)(_this.serializeWireBase.bind(_this));

    _this.hash = hash;
    _this.hashHex = _common2.default.uInt160ToHex(hash);
    _this.isFrozen = isFrozen || false;
    _this.votes = votes || [];
    _this.balances = balances || {};
    return _this;
  }

  (0, _createClass3.default)(Account, [{
    key: 'isDeletable',
    value: function isDeletable() {
      const balances = _utils2.default.values(this.balances);
      return !this.isFrozen && this.votes.length === 0 && (balances.length === 0 || balances.every(value => value.lte(_utils2.default.ZERO)));
    }
  }, {
    key: 'update',
    value: function update({
      isFrozen,
      votes,
      balances
    }) {
      return new Account({
        hash: this.hash,
        isFrozen: isFrozen == null ? this.isFrozen : isFrozen,
        votes: votes == null ? this.votes : votes,
        balances: balances == null ? this.balances : balances
      });
    }
  }, {
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      writer.writeUInt8(this.version);
      writer.writeUInt160(this.hash);
      writer.writeBoolean(this.isFrozen);
      writer.writeArray(this.votes, vote => {
        writer.writeECPoint(vote);
      });
      const balances = _lodash2.default.pickBy(this.balances, value => value.gt(_utils2.default.ZERO));
      writer.writeObject(balances, (key, value) => {
        writer.writeUInt256(key);
        writer.writeFixed8(value);
      });
    }
  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        version: this.version,
        script_hash: _utils.JSONHelper.writeUInt160(this.hash),
        frozen: this.isFrozen,
        votes: this.votes.map(vote => _utils.JSONHelper.writeECPoint(vote)),
        balances: _utils2.default.entries(this.balances).map(([asset, value]) => ({
          asset: _utils.JSONHelper.writeUInt256(asset),
          value: _utils.JSONHelper.writeFixed8(value)
        }))
      };
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase({ reader }) {
      const version = reader.readUInt8();
      const hash = reader.readUInt160();
      const isFrozen = reader.readBoolean();
      const votes = reader.readArray(() => reader.readECPoint());
      const balances = reader.readObject(() => {
        const key = _common2.default.uInt256ToHex(reader.readUInt256());
        const value = reader.readFixed8();
        return { key, value };
      });

      return new this({
        version,
        hash,
        isFrozen,
        votes,
        balances
      });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);
  return Account;
}(_BaseState3.default);

exports.default = Account;