'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toJSONAssetType = exports.assertAssetType = exports.InvalidAssetTypeError = exports.hasFlag = exports.ASSET_TYPE = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const ASSET_TYPE = exports.ASSET_TYPE = {
  CREDIT_FLAG: 0x40,
  DUTY_FLAG: 0x80,
  GOVERNING_TOKEN: 0x00,
  UTILITY_TOKEN: 0x01,
  CURRENCY: 0x08,
  SHARE: 0x90,
  INVOICE: 0x98,
  TOKEN: 0x60
};

const hasFlag = exports.hasFlag = (assetType, flag
// eslint-disable-next-line
) => (assetType & flag) === flag;

let InvalidAssetTypeError = exports.InvalidAssetTypeError = function (_Error) {
  (0, _inherits3.default)(InvalidAssetTypeError, _Error);

  function InvalidAssetTypeError(assetType) {
    (0, _classCallCheck3.default)(this, InvalidAssetTypeError);

    var _this = (0, _possibleConstructorReturn3.default)(this, (InvalidAssetTypeError.__proto__ || (0, _getPrototypeOf2.default)(InvalidAssetTypeError)).call(this, `Expected asset type, found: ${assetType.toString(16)}`));

    _this.assetType = assetType;
    return _this;
  }

  return InvalidAssetTypeError;
}(Error);

const assertAssetType = exports.assertAssetType = assetType => {
  switch (assetType) {
    case ASSET_TYPE.CREDIT_FLAG:
      return ASSET_TYPE.CREDIT_FLAG;
    case ASSET_TYPE.DUTY_FLAG:
      return ASSET_TYPE.DUTY_FLAG;
    case ASSET_TYPE.GOVERNING_TOKEN:
      return ASSET_TYPE.GOVERNING_TOKEN;
    case ASSET_TYPE.UTILITY_TOKEN:
      return ASSET_TYPE.UTILITY_TOKEN;
    case ASSET_TYPE.CURRENCY:
      return ASSET_TYPE.CURRENCY;
    case ASSET_TYPE.SHARE:
      return ASSET_TYPE.SHARE;
    case ASSET_TYPE.INVOICE:
      return ASSET_TYPE.INVOICE;
    case ASSET_TYPE.TOKEN:
      return ASSET_TYPE.TOKEN;
    default:
      throw new InvalidAssetTypeError(assetType);
  }
};

const toJSONAssetType = exports.toJSONAssetType = type => {
  switch (type) {
    case 0x40:
      return 'CreditFlag';
    case 0x80:
      return 'DutyFlag';
    case 0x00:
      return 'GoverningToken';
    case 0x01:
      return 'UtilityToken';
    case 0x08:
      return 'Currency';
    case 0x90:
      return 'Share';
    case 0x98:
      return 'Invoice';
    case 0x60:
      return 'Token';
    default:
      // eslint-disable-next-line
      type;
      throw new InvalidAssetTypeError(type);
  }
};