'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _BlockBase2 = require('./BlockBase');

var _BlockBase3 = _interopRequireDefault(_BlockBase2);

require('./Serializable');

var _errors = require('./errors');

require('./common');

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Header = function (_BlockBase) {
  (0, _inherits3.default)(Header, _BlockBase);

  function Header(add) {
    (0, _classCallCheck3.default)(this, Header);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Header.__proto__ || (0, _getPrototypeOf2.default)(Header)).call(this, add));

    _this.__headerSize = _utils2.default.lazy(() => (0, _get3.default)(Header.prototype.__proto__ || (0, _getPrototypeOf2.default)(Header.prototype), 'size', _this) + _utils.IOHelper.sizeOfUInt8);
    return _this;
  }

  (0, _createClass3.default)(Header, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      (0, _get3.default)(Header.prototype.__proto__ || (0, _getPrototypeOf2.default)(Header.prototype), 'serializeWireBase', this).call(this, writer);
      writer.writeUInt8(0);
    }
  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: (() => {
      var _ref = (0, _asyncToGenerator3.default)(function* (context) {
        return (0, _get3.default)(Header.prototype.__proto__ || (0, _getPrototypeOf2.default)(Header.prototype), 'serializeBlockBaseJSON', this).call(this, context);
      });

      function serializeJSON(_x) {
        return _ref.apply(this, arguments);
      }

      return serializeJSON;
    })()
  }, {
    key: 'size',
    get: function () {
      return this.__headerSize();
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { reader } = options;
      const blockBase = (0, _get3.default)(Header.__proto__ || (0, _getPrototypeOf2.default)(Header), 'deserializeBlockBaseWireBase', this).call(this, options);
      if (reader.readUInt8() !== 0) {
        throw new _errors.InvalidFormatError();
      }

      return new this({
        version: blockBase.version,
        previousHash: blockBase.previousHash,
        merkleRoot: blockBase.merkleRoot,
        timestamp: blockBase.timestamp,
        index: blockBase.index,
        consensusData: blockBase.consensusData,
        nextConsensus: blockBase.nextConsensus,
        script: blockBase.script
      });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);
  return Header;
}(_BlockBase3.default); /* @fl/*  */


exports.default = Header;