'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _utils = require('./utils');

var _Serializable = require('./Serializable');

var _invocationResult = require('./invocationResult');

var _common = require('./common');

var _common2 = _interopRequireDefault(_common);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let InvocationData = function () {
  function InvocationData({
    hash,
    assetHash,
    contractHashes,
    blockIndex,
    transactionIndex,
    result
  }) {
    (0, _classCallCheck3.default)(this, InvocationData);
    this.serializeWire = (0, _Serializable.createSerializeWire)(this.serializeWireBase.bind(this));

    this.hash = hash;
    this.assetHash = assetHash;
    this.contractHashes = contractHashes;
    this.blockIndex = blockIndex;
    this.transactionIndex = transactionIndex;
    this.result = result;
  }

  (0, _createClass3.default)(InvocationData, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      writer.writeUInt256(this.hash);
      writer.writeUInt256(this.assetHash || _common2.default.ZERO_UINT256);
      writer.writeArray(this.contractHashes, contractHash => {
        writer.writeUInt160(contractHash);
      });
      writer.writeUInt32LE(this.blockIndex);
      writer.writeUInt32LE(this.transactionIndex);
      this.result.serializeWireBase(writer);
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { reader } = options;
      const hash = reader.readUInt256();
      const assetHash = reader.readUInt256();
      const contractHashes = reader.readArray(() => reader.readUInt160());
      const blockIndex = reader.readUInt32LE();
      const transactionIndex = reader.readUInt32LE();
      const result = (0, _invocationResult.deserializeWireBase)(options);
      return new this({
        hash,
        assetHash: _common2.default.uInt256Equal(assetHash, _common2.default.ZERO_UINT256) ? undefined : assetHash,
        contractHashes,
        blockIndex,
        transactionIndex,
        result
      });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);
  return InvocationData;
}();

exports.default = InvocationData;