'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assertScriptContainerType = exports.InvalidScriptContainerTypeError = exports.SCRIPT_CONTAINER_TYPE = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const SCRIPT_CONTAINER_TYPE = exports.SCRIPT_CONTAINER_TYPE = {
  TRANSACTION: 0x00,
  BLOCK: 0x01
};

let InvalidScriptContainerTypeError = exports.InvalidScriptContainerTypeError = function (_Error) {
  (0, _inherits3.default)(InvalidScriptContainerTypeError, _Error);

  function InvalidScriptContainerTypeError(value) {
    (0, _classCallCheck3.default)(this, InvalidScriptContainerTypeError);

    var _this = (0, _possibleConstructorReturn3.default)(this, (InvalidScriptContainerTypeError.__proto__ || (0, _getPrototypeOf2.default)(InvalidScriptContainerTypeError)).call(this, `Expected script container type, found: ${value.toString(16)}`));

    _this.value = value;
    return _this;
  }

  return InvalidScriptContainerTypeError;
}(Error);

const assertScriptContainerType = exports.assertScriptContainerType = value => {
  switch (value) {
    case 0x00:
      return SCRIPT_CONTAINER_TYPE.TRANSACTION;
    case 0x01:
      return SCRIPT_CONTAINER_TYPE.BLOCK;
    default:
      throw new InvalidScriptContainerTypeError(value);
  }
};