'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

require('./Equatable');

var _Serializable = require('./Serializable');

var _common = require('./common');

var _common2 = _interopRequireDefault(_common);

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let StorageItem = function () {
  function StorageItem({
    hash,
    key,
    value
  }) {
    (0, _classCallCheck3.default)(this, StorageItem);
    this.equals = _utils2.default.equals(StorageItem, other => _common2.default.uInt160Equal(this.hash, other.hash) && this.key.equals(other.key) && this.value.equals(other.value));
    this.serializeWire = (0, _Serializable.createSerializeWire)(this.serializeWireBase.bind(this));

    this.hash = hash;
    this.key = key;
    this.value = value;
  }

  (0, _createClass3.default)(StorageItem, [{
    key: 'update',
    value: function update({
      value
    }) {
      return new this.constructor({
        hash: this.hash,
        key: this.key,
        value
      });
    }
  }, {
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      writer.writeUInt160(this.hash);
      writer.writeVarBytesLE(this.key);
      writer.writeVarBytesLE(this.value);
    }
  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        hash: _utils.JSONHelper.writeUInt160(this.hash),
        key: _utils.JSONHelper.writeBuffer(this.key),
        value: _utils.JSONHelper.writeBuffer(this.value)
      };
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase({ reader }) {
      const hash = reader.readUInt160();
      const key = reader.readVarBytesLE();
      const value = reader.readVarBytesLE();

      return new this({
        hash,
        key,
        value
      });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);
  return StorageItem;
}();

exports.default = StorageItem;