'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _BaseState2 = require('./BaseState');

var _BaseState3 = _interopRequireDefault(_BaseState2);

require('./Equatable');

var _Serializable = require('./Serializable');

var _common = require('./common');

var _common2 = _interopRequireDefault(_common);

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Validator = function (_BaseState) {
  (0, _inherits3.default)(Validator, _BaseState);

  function Validator({
    version,
    publicKey
  }) {
    (0, _classCallCheck3.default)(this, Validator);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Validator.__proto__ || (0, _getPrototypeOf2.default)(Validator)).call(this, { version }));

    _this.equals = _utils2.default.equals(Validator, other => _common2.default.ecPointEqual(_this.publicKey, other.publicKey));
    _this.serializeWire = (0, _Serializable.createSerializeWire)(_this.serializeWireBase.bind(_this));

    _this.publicKey = publicKey;
    return _this;
  }

  (0, _createClass3.default)(Validator, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      writer.writeUInt8(this.version);
      writer.writeECPoint(this.publicKey);
    }
  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        version: this.version,
        publicKey: _utils.JSONHelper.writeECPoint(this.publicKey)
      };
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase({ reader }) {
      const version = reader.readUInt8();
      const publicKey = reader.readECPoint();

      return new this({ version, publicKey });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);
  return Validator;
}(_BaseState3.default);

exports.default = Validator;