'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

require('./Equatable');

var _Serializable = require('./Serializable');

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Witness = function () {
  function Witness({
    invocation,
    verification
  }) {
    (0, _classCallCheck3.default)(this, Witness);
    this.__size = _utils2.default.lazy(() => _utils.IOHelper.sizeOfVarBytesLE(this.invocation) + _utils.IOHelper.sizeOfVarBytesLE(this.verification));
    this.equals = _utils2.default.equals(Witness, other => this.invocation.equals(other.invocation) && this.verification.equals(other.verification));
    this.serializeWire = (0, _Serializable.createSerializeWire)(this.serializeWireBase.bind(this));

    this.invocation = invocation;
    this.verification = verification;
  }

  (0, _createClass3.default)(Witness, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      writer.writeVarBytesLE(this.invocation);
      writer.writeVarBytesLE(this.verification);
    }
  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        invocation: _utils.JSONHelper.writeBuffer(this.invocation),
        verification: _utils.JSONHelper.writeBuffer(this.verification)
      };
    }
  }, {
    key: 'size',
    get: function () {
      return this.__size();
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase({ reader }) {
      const invocation = reader.readVarBytesLE(_utils2.default.USHORT_MAX_NUMBER_PLUS_ONE);
      const verification = reader.readVarBytesLE(_utils2.default.USHORT_MAX_NUMBER_PLUS_ONE);

      return new this({ invocation, verification });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);
  return Witness;
}();

exports.default = Witness;