'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deserializeWire = exports.deserializeWireBase = undefined;

var _ActionType = require('./ActionType');

var _Serializable = require('../Serializable');

var _LogAction = require('./LogAction');

var _LogAction2 = _interopRequireDefault(_LogAction);

var _NotificationAction = require('./NotificationAction');

var _NotificationAction2 = _interopRequireDefault(_NotificationAction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const deserializeWireBase = exports.deserializeWireBase = options => {
  const { reader } = options;
  const type = (0, _ActionType.assertActionType)(reader.clone().readUInt8());
  switch (type) {
    case 0x00:
      return _LogAction2.default.deserializeWireBase(options);
    case 0x01:
      return _NotificationAction2.default.deserializeWireBase(options);
    default:
      // eslint-disable-next-line
      type;
      throw new _ActionType.InvalidActionTypeError(type);
  }
};

const deserializeWire = exports.deserializeWire = (0, _Serializable.createDeserializeWire)(deserializeWireBase);