'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

require('./ActionType');

var _utils = require('../utils');

var _Serializable = require('../Serializable');

require('../common');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* @/*  */
let ActionBase = function () {
  function ActionBase({
    type,
    version,
    blockIndex,
    blockHash,
    transactionIndex,
    transactionHash,
    index,
    scriptHash
  }) {
    (0, _classCallCheck3.default)(this, ActionBase);

    _initialiseProps.call(this);

    this.type = type;
    this.version = version == null ? this.constructor.VERSION : version;
    this.blockIndex = blockIndex;
    this.blockHash = blockHash;
    this.transactionIndex = transactionIndex;
    this.transactionHash = transactionHash;
    this.index = index;
    this.scriptHash = scriptHash;
  }

  (0, _createClass3.default)(ActionBase, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      writer.writeUInt8(this.type);
      writer.writeUInt8(this.version);
      writer.writeUInt32LE(this.blockIndex);
      writer.writeUInt256(this.blockHash);
      writer.writeUInt32LE(this.transactionIndex);
      writer.writeUInt256(this.transactionHash);
      writer.writeUInt32LE(this.index);
      writer.writeUInt160(this.scriptHash);
    }
  }, {
    key: 'serializeActionBaseJSON',


    // eslint-disable-next-line
    value: function serializeActionBaseJSON(context) {
      return {
        version: this.version,
        blockIndex: this.blockIndex,
        blockHash: _utils.JSONHelper.writeUInt256(this.blockHash),
        transactionIndex: this.transactionIndex,
        transactionHash: _utils.JSONHelper.writeUInt256(this.transactionHash),
        index: this.index,
        scriptHash: _utils.JSONHelper.writeUInt160(this.scriptHash)
      };
    }
  }], [{
    key: 'deserializeWireBase',


    // eslint-disable-next-line
    value: function deserializeWireBase(options) {
      throw new Error('Not Implemented');
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);
  return ActionBase;
}();

ActionBase.VERSION = 0;

ActionBase.deserializeActionBaseWireBase = ({
  reader
}) => {
  const type = reader.readUInt8();
  const version = reader.readUInt8();
  const blockIndex = reader.readUInt32LE();
  const blockHash = reader.readUInt256();
  const transactionIndex = reader.readUInt32LE();
  const transactionHash = reader.readUInt256();
  const index = reader.readUInt32LE();
  const scriptHash = reader.readUInt160();

  return {
    type,
    version,
    blockIndex,
    blockHash,
    transactionIndex,
    transactionHash,
    index,
    scriptHash
  };
};

var _initialiseProps = function () {
  this.serializeWire = (0, _Serializable.createSerializeWire)(this.serializeWireBase.bind(this));
};

exports.default = ActionBase;