'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _ActionType = require('./ActionType');

var _ActionBase2 = require('./ActionBase');

var _ActionBase3 = _interopRequireDefault(_ActionBase2);

require('../utils');

require('../Serializable');

var _contractParameter = require('../contractParameter');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let NotificationAction = function (_ActionBase) {
  (0, _inherits3.default)(NotificationAction, _ActionBase);

  function NotificationAction({
    version,
    blockIndex,
    blockHash,
    transactionIndex,
    transactionHash,
    index,
    scriptHash,
    args
  }) {
    (0, _classCallCheck3.default)(this, NotificationAction);

    var _this = (0, _possibleConstructorReturn3.default)(this, (NotificationAction.__proto__ || (0, _getPrototypeOf2.default)(NotificationAction)).call(this, {
      type: _ActionType.ACTION_TYPE.NOTIFICATION,
      version,
      blockIndex,
      blockHash,
      transactionIndex,
      transactionHash,
      index,
      scriptHash
    }));

    _this.args = args;
    return _this;
  }

  (0, _createClass3.default)(NotificationAction, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      (0, _get3.default)(NotificationAction.prototype.__proto__ || (0, _getPrototypeOf2.default)(NotificationAction.prototype), 'serializeWireBase', this).call(this, writer);
      writer.writeArray(this.args, arg => arg.serializeWireBase(writer));
    }
  }, {
    key: 'serializeJSON',
    value: function serializeJSON(context) {
      const action = (0, _get3.default)(NotificationAction.prototype.__proto__ || (0, _getPrototypeOf2.default)(NotificationAction.prototype), 'serializeActionBaseJSON', this).call(this, context);
      return {
        type: 'Notification',
        version: action.version,
        blockIndex: action.blockIndex,
        blockHash: action.blockHash,
        transactionIndex: action.transactionIndex,
        transactionHash: action.transactionHash,
        index: action.index,
        scriptHash: action.scriptHash,
        args: this.args.map(arg => arg.serializeJSON(context))
      };
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { reader } = options;
      const action = (0, _get3.default)(NotificationAction.__proto__ || (0, _getPrototypeOf2.default)(NotificationAction), 'deserializeActionBaseWireBase', this).call(this, options);
      const args = reader.readArray(() => (0, _contractParameter.deserializeWireBase)(options));

      return new this({
        version: action.version,
        blockIndex: action.blockIndex,
        blockHash: action.blockHash,
        transactionIndex: action.transactionIndex,
        transactionHash: action.transactionHash,
        index: action.index,
        scriptHash: action.scriptHash,
        args
      });
    }
  }]);
  return NotificationAction;
}(_ActionBase3.default);

exports.default = NotificationAction;