'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deserializeWire = exports.deserializeWireBase = undefined;

var _ContractParameterType = require('./ContractParameterType');

var _Serializable = require('../Serializable');

var _SignatureContractParameter = require('./SignatureContractParameter');

var _SignatureContractParameter2 = _interopRequireDefault(_SignatureContractParameter);

var _BooleanContractParameter = require('./BooleanContractParameter');

var _BooleanContractParameter2 = _interopRequireDefault(_BooleanContractParameter);

var _IntegerContractParameter = require('./IntegerContractParameter');

var _IntegerContractParameter2 = _interopRequireDefault(_IntegerContractParameter);

var _Hash160ContractParameter = require('./Hash160ContractParameter');

var _Hash160ContractParameter2 = _interopRequireDefault(_Hash160ContractParameter);

var _Hash256ContractParameter = require('./Hash256ContractParameter');

var _Hash256ContractParameter2 = _interopRequireDefault(_Hash256ContractParameter);

var _ByteArrayContractParameter = require('./ByteArrayContractParameter');

var _ByteArrayContractParameter2 = _interopRequireDefault(_ByteArrayContractParameter);

var _PublicKeyContractParameter = require('./PublicKeyContractParameter');

var _PublicKeyContractParameter2 = _interopRequireDefault(_PublicKeyContractParameter);

var _StringContractParameter = require('./StringContractParameter');

var _StringContractParameter2 = _interopRequireDefault(_StringContractParameter);

var _ArrayContractParameter = require('./ArrayContractParameter');

var _ArrayContractParameter2 = _interopRequireDefault(_ArrayContractParameter);

var _InteropInterfaceContractParameter = require('./InteropInterfaceContractParameter');

var _InteropInterfaceContractParameter2 = _interopRequireDefault(_InteropInterfaceContractParameter);

var _VoidContractParameter = require('./VoidContractParameter');

var _VoidContractParameter2 = _interopRequireDefault(_VoidContractParameter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const deserializeWireBase = exports.deserializeWireBase = options => {
  const { reader } = options;
  const type = (0, _ContractParameterType.assertContractParameterType)(reader.clone().readUInt8());
  switch (type) {
    case 0x00:
      return _SignatureContractParameter2.default.deserializeWireBase(options);
    case 0x01:
      return _BooleanContractParameter2.default.deserializeWireBase(options);
    case 0x02:
      return _IntegerContractParameter2.default.deserializeWireBase(options);
    case 0x03:
      return _Hash160ContractParameter2.default.deserializeWireBase(options);
    case 0x04:
      return _Hash256ContractParameter2.default.deserializeWireBase(options);
    case 0x05:
      return _ByteArrayContractParameter2.default.deserializeWireBase(options);
    case 0x06:
      return _PublicKeyContractParameter2.default.deserializeWireBase(options);
    case 0x07:
      return _StringContractParameter2.default.deserializeWireBase(options);
    case 0x10:
      return _ArrayContractParameter2.default.deserializeWireBase(options);
    case 0xf0:
      return _InteropInterfaceContractParameter2.default.deserializeWireBase(options);
    case 0xff:
      return _VoidContractParameter2.default.deserializeWireBase(options);
    default:
      // eslint-disable-next-line
      type;
      throw new _ContractParameterType.InvalidContractParameterTypeError(type);
  }
};
const deserializeWire = exports.deserializeWire = (0, _Serializable.createDeserializeWire)(deserializeWireBase);

// $FlowFixMe
_ArrayContractParameter2.default.deserializeWireBase = options => {
  const { reader } = options;
  reader.readUInt8();
  const value = reader.readArray(() => deserializeWireBase(options));
  return new _ArrayContractParameter2.default(value);
};

// $FlowFixMe
_ArrayContractParameter2.default.deserializeWire = (0, _Serializable.createDeserializeWire)(_ArrayContractParameter2.default.deserializeWireBase.bind(_ArrayContractParameter2.default));