'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deserializeWire = exports.deserializeWireBase = undefined;

var _InvocationResultType = require('./InvocationResultType');

var _Serializable = require('../Serializable');

var _InvocationResultSuccess = require('./InvocationResultSuccess');

var _InvocationResultSuccess2 = _interopRequireDefault(_InvocationResultSuccess);

var _InvocationResultError = require('./InvocationResultError');

var _InvocationResultError2 = _interopRequireDefault(_InvocationResultError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const deserializeWireBase = exports.deserializeWireBase = options => {
  const { reader } = options;
  const type = (0, _InvocationResultType.assertInvocationResultType)(reader.clone().readUInt8());
  switch (type) {
    case 0x00:
      return _InvocationResultError2.default.deserializeWireBase(options);
    case 0x01:
      return _InvocationResultSuccess2.default.deserializeWireBase(options);
    default:
      // eslint-disable-next-line
      type;
      throw new _InvocationResultType.InvalidInvocationResultTypeError(type);
  }
};

const deserializeWire = exports.deserializeWire = (0, _Serializable.createDeserializeWire)(deserializeWireBase);