'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _TransactionType = require('./TransactionType');

require('../Serializable');

var _Input = require('./Input');

var _Input2 = _interopRequireDefault(_Input);

var _TransactionBase2 = require('./TransactionBase');

var _TransactionBase3 = _interopRequireDefault(_TransactionBase2);

var _errors = require('../errors');

var _common = require('../common');

var _common2 = _interopRequireDefault(_common);

var _common3 = require('./common');

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let ClaimTransaction = function (_TransactionBase) {
  (0, _inherits3.default)(ClaimTransaction, _TransactionBase);

  function ClaimTransaction({
    version,
    attributes,
    inputs,
    outputs,
    scripts,
    hash,
    claims
  }) {
    (0, _classCallCheck3.default)(this, ClaimTransaction);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ClaimTransaction.__proto__ || (0, _getPrototypeOf2.default)(ClaimTransaction)).call(this, {
      version,
      type: _TransactionType.TRANSACTION_TYPE.CLAIM,
      attributes,
      inputs,
      outputs,
      scripts,
      hash
    }));

    _this.claims = claims;

    if (_this.version !== 0) {
      throw new _errors.InvalidFormatError();
    }

    if (_this.claims.length === 0) {
      throw new _errors.InvalidFormatError();
    }

    _this.__size = _utils2.default.lazy(() => (0, _get3.default)(ClaimTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(ClaimTransaction.prototype), 'size', _this) + _utils.IOHelper.sizeOfUInt8 + _utils.IOHelper.sizeOfArray(_this.claims, claim => claim.size));

    _this.__claimGetScriptHashesForVerifying = _utils2.default.lazyAsync((() => {
      var _ref = (0, _asyncToGenerator3.default)(function* (options) {
        const { getOutput } = options;
        const [hashesSet, hashes] = yield _promise2.default.all([(0, _get3.default)(ClaimTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(ClaimTransaction.prototype), 'getScriptHashesForVerifying', _this).call(_this, options), _promise2.default.all(_this.claims.map((() => {
          var _ref2 = (0, _asyncToGenerator3.default)(function* (claim) {
            const output = yield getOutput(claim);
            return _common2.default.uInt160ToHex(output.address);
          });

          return function (_x2) {
            return _ref2.apply(this, arguments);
          };
        })()))]);

        return new _set2.default([...hashesSet, ...hashes]);
      });

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    })());
    return _this;
  }

  (0, _createClass3.default)(ClaimTransaction, [{
    key: 'clone',
    value: function clone(scripts) {
      return new this.constructor({
        version: this.version,
        attributes: this.attributes,
        inputs: this.inputs,
        outputs: this.outputs,
        scripts,
        claims: this.claims
      });
    }
  }, {
    key: 'serializeExclusiveBase',
    value: function serializeExclusiveBase(writer) {
      writer.writeArray(this.claims, claim => {
        claim.serializeWireBase(writer);
      });
    }
  }, {
    key: 'getNetworkFee',


    // eslint-disable-next-line
    value: (() => {
      var _ref3 = (0, _asyncToGenerator3.default)(function* (context) {
        return _utils2.default.ZERO;
      });

      function getNetworkFee(_x3) {
        return _ref3.apply(this, arguments);
      }

      return getNetworkFee;
    })()
  }, {
    key: 'getScriptHashesForVerifying',
    value: (() => {
      var _ref4 = (0, _asyncToGenerator3.default)(function* (options) {
        return this.__claimGetScriptHashesForVerifying(options);
      });

      function getScriptHashesForVerifying(_x4) {
        return _ref4.apply(this, arguments);
      }

      return getScriptHashesForVerifying;
    })()
  }, {
    key: 'verify',
    value: (() => {
      var _ref5 = (0, _asyncToGenerator3.default)(function* (options) {
        yield _promise2.default.all([(0, _get3.default)(ClaimTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(ClaimTransaction.prototype), 'verify', this).call(this, options), this._verify(options)]);
      });

      function verify(_x5) {
        return _ref5.apply(this, arguments);
      }

      return verify;
    })()
  }, {
    key: '_verify',
    value: (() => {
      var _ref6 = (0, _asyncToGenerator3.default)(function* (options) {
        var _this2 = this;

        const {
          calculateClaimAmount,
          getOutput,
          utilityToken,
          memPool = []
        } = options;
        if ((0, _common3.hasDuplicateInputs)(this.claims)) {
          throw new _errors.VerifyError('Duplicate claims');
        }

        if (memPool.some(function (transaction) {
          return transaction instanceof ClaimTransaction && transaction.type === _TransactionType.TRANSACTION_TYPE.CLAIM && (0, _common3.hasIntersectingInputs)(_this2.claims, transaction.claims);
        })) {
          throw new _errors.VerifyError('Dupliate claims in mempool');
        }
        const [results, claimAmount] = yield _promise2.default.all([this.getTransactionResults({ getOutput }), calculateClaimAmount(this.claims).catch(function (error) {
          throw new _errors.VerifyError(`Invalid claims: ${error.message}`);
        })]);
        const result = _utils2.default.entries(results).find(
        // eslint-disable-next-line
        function ([assetHex, _]) {
          return _common2.default.uInt256Equal(_common2.default.hexToUInt256(assetHex), utilityToken.hash);
        });
        if (result == null || result[1].gt(_utils2.default.ZERO)) {
          throw new _errors.VerifyError('Invalid claim value');
        }

        if (!claimAmount.eq(result[1].neg())) {
          throw new _errors.VerifyError('Invalid claim value');
        }
      });

      function _verify(_x6) {
        return _ref6.apply(this, arguments);
      }

      return _verify;
    })()

    // eslint-disable-next-line

  }, {
    key: 'serializeJSON',
    value: (() => {
      var _ref7 = (0, _asyncToGenerator3.default)(function* (context) {
        const transactionBaseJSON = yield (0, _get3.default)(ClaimTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(ClaimTransaction.prototype), 'serializeTransactionBaseJSON', this).call(this, context);

        return {
          type: 'ClaimTransaction',
          txid: transactionBaseJSON.txid,
          size: transactionBaseJSON.size,
          version: transactionBaseJSON.version,
          attributes: transactionBaseJSON.attributes,
          vin: transactionBaseJSON.vin,
          vout: transactionBaseJSON.vout,
          scripts: transactionBaseJSON.scripts,
          sys_fee: transactionBaseJSON.sys_fee,
          net_fee: transactionBaseJSON.net_fee,
          claims: this.claims.map(function (claim) {
            return claim.serializeJSON(context);
          })
        };
      });

      function serializeJSON(_x7) {
        return _ref7.apply(this, arguments);
      }

      return serializeJSON;
    })()
  }, {
    key: 'size',
    get: function () {
      return this.__size();
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { reader } = options;

      const { type, version } = (0, _get3.default)(ClaimTransaction.__proto__ || (0, _getPrototypeOf2.default)(ClaimTransaction), 'deserializeTransactionBaseStartWireBase', this).call(this, options);
      if (type !== _TransactionType.TRANSACTION_TYPE.CLAIM) {
        throw new _errors.InvalidFormatError();
      }

      const claims = reader.readArray(() => _Input2.default.deserializeWireBase(options));

      const { attributes, inputs, outputs, scripts } = (0, _get3.default)(ClaimTransaction.__proto__ || (0, _getPrototypeOf2.default)(ClaimTransaction), 'deserializeTransactionBaseEndWireBase', this).call(this, options);

      return new this({
        version,
        claims,
        attributes,
        inputs,
        outputs,
        scripts
      });
    }
  }]);
  return ClaimTransaction;
}(_TransactionBase3.default);

exports.default = ClaimTransaction;