'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _TransactionType = require('./TransactionType');

require('../Serializable');

var _TransactionBase2 = require('./TransactionBase');

var _TransactionBase3 = _interopRequireDefault(_TransactionBase2);

var _errors = require('../errors');

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let ContractTransaction = function (_TransactionBase) {
  (0, _inherits3.default)(ContractTransaction, _TransactionBase);

  function ContractTransaction({
    version,
    attributes,
    inputs,
    outputs,
    scripts,
    hash
  }) {
    (0, _classCallCheck3.default)(this, ContractTransaction);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ContractTransaction.__proto__ || (0, _getPrototypeOf2.default)(ContractTransaction)).call(this, {
      version,
      type: _TransactionType.TRANSACTION_TYPE.CONTRACT,
      attributes,
      inputs,
      outputs,
      scripts,
      hash
    }));

    if (_this.version !== 0) {
      throw new _errors.InvalidFormatError();
    }

    _this.__size = _utils2.default.lazy(() => (0, _get3.default)(ContractTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(ContractTransaction.prototype), 'size', _this) + _utils.IOHelper.sizeOfUInt8);
    return _this;
  }

  (0, _createClass3.default)(ContractTransaction, [{
    key: 'clone',
    value: function clone(scripts) {
      return new this.constructor({
        version: this.version,
        attributes: this.attributes,
        inputs: this.inputs,
        outputs: this.outputs,
        scripts
      });
    }

    // eslint-disable-next-line

  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: (() => {
      var _ref = (0, _asyncToGenerator3.default)(function* (context) {
        const transactionBaseJSON = yield (0, _get3.default)(ContractTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(ContractTransaction.prototype), 'serializeTransactionBaseJSON', this).call(this, context);

        return {
          type: 'ContractTransaction',
          txid: transactionBaseJSON.txid,
          size: transactionBaseJSON.size,
          version: transactionBaseJSON.version,
          attributes: transactionBaseJSON.attributes,
          vin: transactionBaseJSON.vin,
          vout: transactionBaseJSON.vout,
          scripts: transactionBaseJSON.scripts,
          sys_fee: transactionBaseJSON.sys_fee,
          net_fee: transactionBaseJSON.net_fee
        };
      });

      function serializeJSON(_x) {
        return _ref.apply(this, arguments);
      }

      return serializeJSON;
    })()
  }, {
    key: 'size',
    get: function () {
      return this.__size();
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { type, version } = (0, _get3.default)(ContractTransaction.__proto__ || (0, _getPrototypeOf2.default)(ContractTransaction), 'deserializeTransactionBaseStartWireBase', this).call(this, options);
      if (type !== _TransactionType.TRANSACTION_TYPE.CONTRACT) {
        throw new _errors.InvalidFormatError();
      }

      const { attributes, inputs, outputs, scripts } = (0, _get3.default)(ContractTransaction.__proto__ || (0, _getPrototypeOf2.default)(ContractTransaction), 'deserializeTransactionBaseEndWireBase', this).call(this, options);

      return new this({
        version,
        attributes,
        inputs,
        outputs,
        scripts
      });
    }
  }]);
  return ContractTransaction;
}(_TransactionBase3.default);

exports.default = ContractTransaction;