'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

require('../Equatable');

var _Serializable = require('../Serializable');

var _common = require('../common');

var _common2 = _interopRequireDefault(_common);

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Input = function () {
  function Input({ hash, index }) {
    (0, _classCallCheck3.default)(this, Input);
    this.size = _utils.IOHelper.sizeOfUInt256 + _utils.IOHelper.sizeOfUInt16LE;
    this.equals = _utils2.default.equals(Input, other => _common2.default.uInt256Equal(this.hash, other.hash) && other.index === this.index);
    this.serializeWire = (0, _Serializable.createSerializeWire)(this.serializeWireBase.bind(this));

    this.hash = hash;
    this.index = index;
  }

  (0, _createClass3.default)(Input, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      writer.writeUInt256(this.hash);
      writer.writeUInt16LE(this.index);
    }
  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        txid: _utils.JSONHelper.writeUInt256(this.hash),
        vout: this.index
      };
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase({ reader }) {
      const hash = reader.readUInt256();
      const index = reader.readUInt16LE();
      return new this({ hash, index });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);
  return Input;
}();

exports.default = Input;