'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _TransactionType = require('./TransactionType');

require('../Serializable');

var _TransactionBase2 = require('./TransactionBase');

var _TransactionBase3 = _interopRequireDefault(_TransactionBase2);

var _errors = require('../errors');

var _common = require('../common');

var _common2 = _interopRequireDefault(_common);

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let IssueTransaction = function (_TransactionBase) {
  (0, _inherits3.default)(IssueTransaction, _TransactionBase);

  // TODO: How is version set?
  // static VERSION = 1;

  function IssueTransaction({
    version,
    attributes,
    inputs,
    outputs,
    scripts,
    hash
  }) {
    (0, _classCallCheck3.default)(this, IssueTransaction);

    var _this = (0, _possibleConstructorReturn3.default)(this, (IssueTransaction.__proto__ || (0, _getPrototypeOf2.default)(IssueTransaction)).call(this, {
      version,
      type: _TransactionType.TRANSACTION_TYPE.ISSUE,
      attributes,
      inputs,
      outputs,
      scripts,
      hash
    }));

    if (_this.version > 1) {
      throw new _errors.InvalidFormatError();
    }
    _this.__size = _utils2.default.lazy(() => (0, _get3.default)(IssueTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(IssueTransaction.prototype), 'size', _this) + _utils.IOHelper.sizeOfUInt8);
    _this.__issueGetScriptHashesForVerifying = _utils2.default.lazyAsync((() => {
      var _ref = (0, _asyncToGenerator3.default)(function* (options) {
        const { getOutput, getAsset } = options;
        const [hashes, issuerHashes] = yield _promise2.default.all([(0, _get3.default)(IssueTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(IssueTransaction.prototype), 'getScriptHashesForVerifying', _this).call(_this, options), _this.getTransactionResults({ getOutput }).then(function (results) {
          return _promise2.default.all(_utils2.default.entries(results)
          // eslint-disable-next-line
          .filter(function ([_, value]) {
            return value.lt(_utils2.default.ZERO);
          })
          // eslint-disable-next-line
          .map((() => {
            var _ref2 = (0, _asyncToGenerator3.default)(function* ([hash, _]) {
              const asset = yield getAsset({ hash: _common2.default.hexToUInt256(hash) });
              return _common2.default.uInt160ToHex(asset.issuer);
            });

            return function (_x2) {
              return _ref2.apply(this, arguments);
            };
          })()));
        })]);
        return new _set2.default([...hashes, ...issuerHashes]);
      });

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    })());
    return _this;
  }

  (0, _createClass3.default)(IssueTransaction, [{
    key: 'clone',
    value: function clone(scripts) {
      return new this.constructor({
        version: this.version,
        attributes: this.attributes,
        inputs: this.inputs,
        outputs: this.outputs,
        scripts
      });
    }

    // eslint-disable-next-line

  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: (() => {
      var _ref3 = (0, _asyncToGenerator3.default)(function* (context) {
        const transactionBaseJSON = yield (0, _get3.default)(IssueTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(IssueTransaction.prototype), 'serializeTransactionBaseJSON', this).call(this, context);

        return {
          type: 'IssueTransaction',
          txid: transactionBaseJSON.txid,
          size: transactionBaseJSON.size,
          version: transactionBaseJSON.version,
          attributes: transactionBaseJSON.attributes,
          vin: transactionBaseJSON.vin,
          vout: transactionBaseJSON.vout,
          scripts: transactionBaseJSON.scripts,
          sys_fee: transactionBaseJSON.sys_fee,
          net_fee: transactionBaseJSON.net_fee
        };
      });

      function serializeJSON(_x3) {
        return _ref3.apply(this, arguments);
      }

      return serializeJSON;
    })()
  }, {
    key: 'getSystemFee',
    value: function getSystemFee(context) {
      if (this.version >= 1) {
        return _utils2.default.ZERO;
      }

      const { governingToken, utilityToken } = context;
      if (this.outputs.every(output => _common2.default.uInt256Equal(output.asset, governingToken.hash) || _common2.default.uInt256Equal(output.asset, utilityToken.hash))) {
        return _utils2.default.ZERO;
      }

      return (0, _get3.default)(IssueTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(IssueTransaction.prototype), 'getSystemFee', this).call(this, context);
    }
  }, {
    key: 'getScriptHashesForVerifying',
    value: (() => {
      var _ref4 = (0, _asyncToGenerator3.default)(function* (options) {
        return this.__issueGetScriptHashesForVerifying(options);
      });

      function getScriptHashesForVerifying(_x4) {
        return _ref4.apply(this, arguments);
      }

      return getScriptHashesForVerifying;
    })()
  }, {
    key: 'verify',
    value: (() => {
      var _ref5 = (0, _asyncToGenerator3.default)(function* (options) {
        yield _promise2.default.all([(0, _get3.default)(IssueTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(IssueTransaction.prototype), 'verify', this).call(this, options), this._verify(options)]);
      });

      function verify(_x5) {
        return _ref5.apply(this, arguments);
      }

      return verify;
    })()
  }, {
    key: '_verify',
    value: (() => {
      var _ref6 = (0, _asyncToGenerator3.default)(function* (options) {
        var _this2 = this;

        const { getOutput, getAsset, memPool = [] } = options;
        const results = yield this.getTransactionResults({ getOutput });
        yield _promise2.default.all(_utils2.default.entries(results).map((() => {
          var _ref7 = (0, _asyncToGenerator3.default)(function* ([assetHex, value]) {
            const hash = _common2.default.hexToUInt256(assetHex);
            const asset = yield getAsset({ hash });
            if (asset.amount.lt(_utils2.default.ZERO)) {
              return;
            }

            const issued = asset.available.add(memPool.filter(function (transaction) {
              return transaction !== _this2;
            }).reduce(function (acc, transaction) {
              return transaction.outputs.filter(function (output) {
                return _common2.default.uInt256Equal(hash, output.asset);
              }).reduce(function (innerAcc, output) {
                return innerAcc.add(output.value);
              }, acc);
            }, _utils2.default.ZERO));
            if (asset.amount.sub(issued).lt(value.neg())) {
              throw new _errors.VerifyError('Invalid issue amount');
            }
          });

          return function (_x7) {
            return _ref7.apply(this, arguments);
          };
        })()));
      });

      function _verify(_x6) {
        return _ref6.apply(this, arguments);
      }

      return _verify;
    })()
  }, {
    key: 'size',
    get: function () {
      return this.__size();
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { type, version } = (0, _get3.default)(IssueTransaction.__proto__ || (0, _getPrototypeOf2.default)(IssueTransaction), 'deserializeTransactionBaseStartWireBase', this).call(this, options);
      if (type !== _TransactionType.TRANSACTION_TYPE.ISSUE) {
        throw new _errors.InvalidFormatError();
      }

      const { attributes, inputs, outputs, scripts } = (0, _get3.default)(IssueTransaction.__proto__ || (0, _getPrototypeOf2.default)(IssueTransaction), 'deserializeTransactionBaseEndWireBase', this).call(this, options);

      return new this({
        version,
        attributes,
        inputs,
        outputs,
        scripts
      });
    }
  }]);
  return IssueTransaction;
}(_TransactionBase3.default);

exports.default = IssueTransaction;