'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _TransactionType = require('./TransactionType');

require('../Serializable');

var _TransactionBase2 = require('./TransactionBase');

var _TransactionBase3 = _interopRequireDefault(_TransactionBase2);

var _errors = require('../errors');

var _common = require('../common');

var _common2 = _interopRequireDefault(_common);

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let MinerTransaction = function (_TransactionBase) {
  (0, _inherits3.default)(MinerTransaction, _TransactionBase);

  function MinerTransaction({
    version,
    attributes,
    inputs,
    outputs,
    scripts,
    hash,
    nonce
  }) {
    (0, _classCallCheck3.default)(this, MinerTransaction);

    var _this = (0, _possibleConstructorReturn3.default)(this, (MinerTransaction.__proto__ || (0, _getPrototypeOf2.default)(MinerTransaction)).call(this, {
      version,
      type: _TransactionType.TRANSACTION_TYPE.MINER,
      attributes,
      inputs,
      outputs,
      scripts,
      hash
    }));

    _this.nonce = nonce;

    if (_this.version !== 0) {
      throw new _errors.InvalidFormatError();
    }

    _this.__size = _utils2.default.lazy(() => (0, _get3.default)(MinerTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(MinerTransaction.prototype), 'size', _this) + _utils.IOHelper.sizeOfUInt8 + _utils.IOHelper.sizeOfUInt32LE);
    return _this;
  }

  (0, _createClass3.default)(MinerTransaction, [{
    key: 'clone',
    value: function clone(scripts) {
      return new this.constructor({
        version: this.version,
        attributes: this.attributes,
        inputs: this.inputs,
        outputs: this.outputs,
        scripts,
        nonce: this.nonce
      });
    }
  }, {
    key: 'serializeExclusiveBase',
    value: function serializeExclusiveBase(writer) {
      writer.writeUInt32LE(this.nonce);
    }

    // eslint-disable-next-line

  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: (() => {
      var _ref = (0, _asyncToGenerator3.default)(function* (context) {
        const transactionBaseJSON = yield (0, _get3.default)(MinerTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(MinerTransaction.prototype), 'serializeTransactionBaseJSON', this).call(this, context);

        return {
          type: 'MinerTransaction',
          txid: transactionBaseJSON.txid,
          size: transactionBaseJSON.size,
          version: transactionBaseJSON.version,
          attributes: transactionBaseJSON.attributes,
          vin: transactionBaseJSON.vin,
          vout: transactionBaseJSON.vout,
          scripts: transactionBaseJSON.scripts,
          sys_fee: transactionBaseJSON.sys_fee,
          net_fee: transactionBaseJSON.net_fee,
          nonce: this.nonce
        };
      });

      function serializeJSON(_x) {
        return _ref.apply(this, arguments);
      }

      return serializeJSON;
    })()

    // eslint-disable-next-line

  }, {
    key: 'getNetworkFee',
    value: (() => {
      var _ref2 = (0, _asyncToGenerator3.default)(function* (context) {
        return _utils2.default.ZERO;
      });

      function getNetworkFee(_x2) {
        return _ref2.apply(this, arguments);
      }

      return getNetworkFee;
    })()
  }, {
    key: 'verify',
    value: (() => {
      var _ref3 = (0, _asyncToGenerator3.default)(function* (options) {
        yield _promise2.default.all([(0, _get3.default)(MinerTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(MinerTransaction.prototype), 'verify', this).call(this, options), this._verify(options)]);
      });

      function verify(_x3) {
        return _ref3.apply(this, arguments);
      }

      return verify;
    })()
  }, {
    key: '_verify',
    value: (() => {
      var _ref4 = (0, _asyncToGenerator3.default)(function* (options) {
        const { getOutput, utilityToken } = options;
        const results = yield this.getTransactionResults({ getOutput });
        const resultsIssue = _utils2.default.entries(results).filter(
        // eslint-disable-next-line
        function ([_, value]) {
          return value.lt(_utils2.default.ZERO);
        });

        // eslint-disable-next-line
        if (resultsIssue.some(function ([assetHex, _]) {
          return !_common2.default.uInt256Equal(_common2.default.hexToUInt256(assetHex), utilityToken.hash);
        })) {
          throw new _errors.VerifyError('Invalid miner result');
        }
      });

      function _verify(_x4) {
        return _ref4.apply(this, arguments);
      }

      return _verify;
    })()
  }, {
    key: 'size',
    get: function () {
      return this.__size();
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { reader } = options;
      const { type, version } = (0, _get3.default)(MinerTransaction.__proto__ || (0, _getPrototypeOf2.default)(MinerTransaction), 'deserializeTransactionBaseStartWireBase', this).call(this, options);
      if (type !== _TransactionType.TRANSACTION_TYPE.MINER) {
        throw new _errors.InvalidFormatError();
      }

      const nonce = reader.readUInt32LE();

      const { attributes, inputs, outputs, scripts } = (0, _get3.default)(MinerTransaction.__proto__ || (0, _getPrototypeOf2.default)(MinerTransaction), 'deserializeTransactionBaseEndWireBase', this).call(this, options);

      return new this({
        version,
        attributes,
        inputs,
        outputs,
        scripts,
        nonce
      });
    }
  }]);
  return MinerTransaction;
}(_TransactionBase3.default);

exports.default = MinerTransaction;