'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

require('../Equatable');

var _Serializable = require('../Serializable');

var _common = require('../common');

var _common2 = _interopRequireDefault(_common);

var _crypto = require('../crypto');

var _crypto2 = _interopRequireDefault(_crypto);

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Output = function () {
  function Output({ asset, value, address }) {
    (0, _classCallCheck3.default)(this, Output);
    this.size = _utils.IOHelper.sizeOfUInt256 + _utils.IOHelper.sizeOfUInt16LE + _utils.IOHelper.sizeOfUInt160;
    this.equals = _utils2.default.equals(Output, other => _common2.default.uInt256Equal(this.asset, other.asset) && this.value.eq(other.value) && _common2.default.uInt160Equal(this.address, other.address));
    this.serializeWire = (0, _Serializable.createSerializeWire)(this.serializeWireBase.bind(this));

    this.asset = asset;
    this.value = value;
    this.address = address;
  }

  (0, _createClass3.default)(Output, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      writer.writeUInt256(this.asset);
      writer.writeFixed8(this.value);
      writer.writeUInt160(this.address);
    }
  }, {
    key: 'serializeJSON',


    // TODO: Maybe store index on Output directly? And add it when deserializing
    //       from transaction
    // eslint-disable-next-line
    value: function serializeJSON(context, index) {
      return {
        n: index,
        asset: _utils.JSONHelper.writeUInt256(this.asset),
        value: _utils.JSONHelper.writeFixed8(this.value),
        address: _crypto2.default.scriptHashToAddress({
          addressVersion: context.addressVersion,
          scriptHash: this.address
        })
      };
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase({ reader }) {
      const asset = reader.readUInt256();
      const value = reader.readFixed8();
      const address = reader.readUInt160();
      return new this({ asset, value, address });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);
  return Output;
}();

exports.default = Output;