'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _TransactionType = require('./TransactionType');

var _Contract = require('../Contract');

var _Contract2 = _interopRequireDefault(_Contract);

require('../Serializable');

var _TransactionBase2 = require('./TransactionBase');

var _TransactionBase3 = _interopRequireDefault(_TransactionBase2);

var _errors = require('../errors');

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let PublishTransaction = function (_TransactionBase) {
  (0, _inherits3.default)(PublishTransaction, _TransactionBase);

  // TODO: How is version set?
  // static VERSION = 1;
  function PublishTransaction({
    version,
    attributes,
    inputs,
    outputs,
    scripts,
    hash,
    contract
  }) {
    (0, _classCallCheck3.default)(this, PublishTransaction);

    var _this = (0, _possibleConstructorReturn3.default)(this, (PublishTransaction.__proto__ || (0, _getPrototypeOf2.default)(PublishTransaction)).call(this, {
      version,
      type: _TransactionType.TRANSACTION_TYPE.PUBLISH,
      attributes,
      inputs,
      outputs,
      scripts,
      hash
    }));

    _this.contract = contract;

    if (_this.version > 1) {
      throw new _errors.InvalidFormatError();
    }

    _this.__size = _utils2.default.lazy(() => (0, _get3.default)(PublishTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(PublishTransaction.prototype), 'size', _this) + _utils.IOHelper.sizeOfUInt8 + (0, _Contract.sizeOfContract)({
      script: _this.contract.script,
      parameterList: _this.contract.parameterList,
      name: _this.contract.name,
      codeVersion: _this.contract.codeVersion,
      author: _this.contract.author,
      email: _this.contract.email,
      description: _this.contract.description,
      publishVersion: _this.version
    }));
    return _this;
  }

  (0, _createClass3.default)(PublishTransaction, [{
    key: 'clone',
    value: function clone(scripts) {
      return new this.constructor({
        version: this.version,
        attributes: this.attributes,
        inputs: this.inputs,
        outputs: this.outputs,
        scripts,
        contract: this.contract
      });
    }
  }, {
    key: 'serializeExclusiveBase',
    value: function serializeExclusiveBase(writer) {
      (0, _Contract.serializeContractWireBase)({
        contract: this.contract,
        writer,
        publishVersion: this.version
      });
    }
  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: (() => {
      var _ref = (0, _asyncToGenerator3.default)(function* (context) {
        const transactionBaseJSON = yield (0, _get3.default)(PublishTransaction.prototype.__proto__ || (0, _getPrototypeOf2.default)(PublishTransaction.prototype), 'serializeTransactionBaseJSON', this).call(this, context);

        return {
          type: 'PublishTransaction',
          txid: transactionBaseJSON.txid,
          size: transactionBaseJSON.size,
          version: transactionBaseJSON.version,
          attributes: transactionBaseJSON.attributes,
          vin: transactionBaseJSON.vin,
          vout: transactionBaseJSON.vout,
          scripts: transactionBaseJSON.scripts,
          sys_fee: transactionBaseJSON.sys_fee,
          net_fee: transactionBaseJSON.net_fee,
          contract: this.contract.serializeJSON(context)
        };
      });

      function serializeJSON(_x) {
        return _ref.apply(this, arguments);
      }

      return serializeJSON;
    })()

    // eslint-disable-next-line

  }, {
    key: 'verify',
    value: (() => {
      var _ref2 = (0, _asyncToGenerator3.default)(function* (options) {
        throw new _errors.VerifyError('Enrollment transactions are obsolete');
      });

      function verify(_x2) {
        return _ref2.apply(this, arguments);
      }

      return verify;
    })()
  }, {
    key: 'size',
    get: function () {
      return this.__size();
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { type, version } = (0, _get3.default)(PublishTransaction.__proto__ || (0, _getPrototypeOf2.default)(PublishTransaction), 'deserializeTransactionBaseStartWireBase', this).call(this, options);
      if (type !== _TransactionType.TRANSACTION_TYPE.PUBLISH) {
        throw new _errors.InvalidFormatError();
      }

      const contract = (0, _Contract.deserializeContractWireBase)((0, _extends3.default)({}, options, {
        publishVersion: version
      }));

      const { attributes, inputs, outputs, scripts } = (0, _get3.default)(PublishTransaction.__proto__ || (0, _getPrototypeOf2.default)(PublishTransaction), 'deserializeTransactionBaseEndWireBase', this).call(this, options);

      return new this({
        version,
        attributes,
        inputs,
        outputs,
        scripts,
        contract
      });
    }
  }]);
  return PublishTransaction;
}(_TransactionBase3.default);

exports.default = PublishTransaction;