'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deserializeWire = exports.deserializeWireBase = undefined;

var _TransactionType = require('./TransactionType');

var _Serializable = require('../Serializable');

require('../common');

var _MinerTransaction = require('./MinerTransaction');

var _MinerTransaction2 = _interopRequireDefault(_MinerTransaction);

var _IssueTransaction = require('./IssueTransaction');

var _IssueTransaction2 = _interopRequireDefault(_IssueTransaction);

var _ClaimTransaction = require('./ClaimTransaction');

var _ClaimTransaction2 = _interopRequireDefault(_ClaimTransaction);

var _EnrollmentTransaction = require('./EnrollmentTransaction');

var _EnrollmentTransaction2 = _interopRequireDefault(_EnrollmentTransaction);

var _RegisterTransaction = require('./RegisterTransaction');

var _RegisterTransaction2 = _interopRequireDefault(_RegisterTransaction);

var _ContractTransaction = require('./ContractTransaction');

var _ContractTransaction2 = _interopRequireDefault(_ContractTransaction);

var _PublishTransaction = require('./PublishTransaction');

var _PublishTransaction2 = _interopRequireDefault(_PublishTransaction);

var _InvocationTransaction = require('./InvocationTransaction');

var _InvocationTransaction2 = _interopRequireDefault(_InvocationTransaction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const deserializeWireBase = exports.deserializeWireBase = options => {
  const { reader } = options;
  const type = (0, _TransactionType.assertTransactionType)(reader.clone().readUInt8());
  switch (type) {
    case 0x00:
      return _MinerTransaction2.default.deserializeWireBase(options);
    case 0x01:
      return _IssueTransaction2.default.deserializeWireBase(options);
    case 0x02:
      return _ClaimTransaction2.default.deserializeWireBase(options);
    case 0x20:
      return _EnrollmentTransaction2.default.deserializeWireBase(options);
    case 0x40:
      return _RegisterTransaction2.default.deserializeWireBase(options);
    case 0x80:
      return _ContractTransaction2.default.deserializeWireBase(options);
    case 0xd0:
      return _PublishTransaction2.default.deserializeWireBase(options);
    case 0xd1:
      return _InvocationTransaction2.default.deserializeWireBase(options);
    default:
      // eslint-disable-next-line
      type;
      throw new _TransactionType.InvalidTransactionTypeError(type);
  }
};
const deserializeWire = exports.deserializeWire = (0, _Serializable.createDeserializeWire)(deserializeWireBase);