"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assertTransactionType = exports.InvalidTransactionTypeError = exports.TRANSACTION_TYPE = undefined;

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const TRANSACTION_TYPE = exports.TRANSACTION_TYPE = {
  MINER: 0x00,
  ISSUE: 0x01,
  CLAIM: 0x02,
  ENROLLMENT: 0x20,
  REGISTER: 0x40,
  CONTRACT: 0x80,
  PUBLISH: 0xd0,
  INVOCATION: 0xd1
};

let InvalidTransactionTypeError = exports.InvalidTransactionTypeError = function (_Error) {
  (0, _inherits3.default)(InvalidTransactionTypeError, _Error);

  function InvalidTransactionTypeError(transactionType) {
    (0, _classCallCheck3.default)(this, InvalidTransactionTypeError);

    var _this = (0, _possibleConstructorReturn3.default)(this, (InvalidTransactionTypeError.__proto__ || (0, _getPrototypeOf2.default)(InvalidTransactionTypeError)).call(this, `Expected transaction type, found: ${transactionType.toString(16)}`));

    _this.transactionType = transactionType;
    return _this;
  }

  return InvalidTransactionTypeError;
}(Error);

const assertTransactionType = exports.assertTransactionType = value => {
  switch (value) {
    case 0x00:
      // Miner
      return 0x00;
    case 0x01:
      // Issue
      return 0x01;
    case 0x02:
      // Claim
      return 0x02;
    case 0x20:
      // Enrollment
      return 0x20;
    case 0x40:
      // Register
      return 0x40;
    case 0x80:
      // Contract
      return 0x80;
    case 0xd0:
      // Publish
      return 0xd0;
    case 0xd1:
      // Invocation
      return 0xd1;
    default:
      throw new InvalidTransactionTypeError(value);
  }
};