'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _AttributeBase2 = require('./AttributeBase');

var _AttributeBase3 = _interopRequireDefault(_AttributeBase2);

require('../../Serializable');

var _errors = require('../../errors');

var _AttributeUsage = require('./AttributeUsage');

var _utils = require('../../utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let BufferAttribute = function (_AttributeBase) {
  (0, _inherits3.default)(BufferAttribute, _AttributeBase);

  function BufferAttribute({ usage, value }) {
    (0, _classCallCheck3.default)(this, BufferAttribute);

    var _this = (0, _possibleConstructorReturn3.default)(this, (BufferAttribute.__proto__ || (0, _getPrototypeOf2.default)(BufferAttribute)).call(this));

    _this.equals = _utils2.default.equals(BufferAttribute, other => _this.usage === other.usage && _this.value.equals(other.value));

    _this.usage = usage;
    _this.value = value;
    if (_this.usage === 0x81) {
      _this.size = _utils.IOHelper.sizeOfUInt8 + _utils.IOHelper.sizeOfUInt8 + _this.value.length;
    } else {
      _this.size = _utils.IOHelper.sizeOfUInt8 + _utils.IOHelper.sizeOfVarBytesLE(_this.value);
    }
    return _this;
  }

  (0, _createClass3.default)(BufferAttribute, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      (0, _get3.default)(BufferAttribute.prototype.__proto__ || (0, _getPrototypeOf2.default)(BufferAttribute.prototype), 'serializeWireBase', this).call(this, writer);
      if (this.usage === 0x81) {
        writer.writeUInt8(this.value.length);
        writer.writeBytes(this.value);
      } else {
        writer.writeVarBytesLE(this.value);
      }
    }

    // eslint-disable-next-line

  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        usage: (0, _AttributeUsage.toJSONAttributeUsage)(this.usage),
        data: _utils.JSONHelper.writeBuffer(this.value)
      };
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { reader } = options;
      const { usage } = (0, _get3.default)(BufferAttribute.__proto__ || (0, _getPrototypeOf2.default)(BufferAttribute), 'deserializeAttributeWireBase', this).call(this, options);
      if (!(usage === 0x81 || usage === 0x90 || usage === 0xf0 || usage === 0xf1 || usage === 0xf2 || usage === 0xf3 || usage === 0xf4 || usage === 0xf5 || usage === 0xf6 || usage === 0xf7 || usage === 0xf8 || usage === 0xf9 || usage === 0xfa || usage === 0xfb || usage === 0xfc || usage === 0xfd || usage === 0xfe || usage === 0xff)) {
        throw new _errors.InvalidFormatError();
      }
      let value;
      if (usage === 0x81) {
        value = reader.readBytes(reader.readUInt8());
      } else {
        value = reader.readVarBytesLE();
      }

      return new this({ usage, value });
    }
  }]);
  return BufferAttribute;
}(_AttributeBase3.default);

exports.default = BufferAttribute;