'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _AttributeBase2 = require('./AttributeBase');

var _AttributeBase3 = _interopRequireDefault(_AttributeBase2);

require('../../Serializable');

var _errors = require('../../errors');

var _AttributeUsage = require('./AttributeUsage');

var _common = require('../../common');

var _common2 = _interopRequireDefault(_common);

var _utils = require('../../utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let ECPointAttribute = function (_AttributeBase) {
  (0, _inherits3.default)(ECPointAttribute, _AttributeBase);

  function ECPointAttribute({ usage, value }) {
    (0, _classCallCheck3.default)(this, ECPointAttribute);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ECPointAttribute.__proto__ || (0, _getPrototypeOf2.default)(ECPointAttribute)).call(this));

    _this.equals = _utils2.default.equals(ECPointAttribute, other => _this.usage === other.usage && _common2.default.ecPointEqual(_this.value, other.value));

    _this.usage = usage;
    _this.value = value;
    _this.size = _utils.IOHelper.sizeOfUInt8 + _utils.IOHelper.sizeOfECPoint(_this.value);
    return _this;
  }

  (0, _createClass3.default)(ECPointAttribute, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      (0, _get3.default)(ECPointAttribute.prototype.__proto__ || (0, _getPrototypeOf2.default)(ECPointAttribute.prototype), 'serializeWireBase', this).call(this, writer);
      writer.writeBytes(_common2.default.ecPointToBuffer(this.value).slice(1));
    }

    // eslint-disable-next-line

  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        usage: (0, _AttributeUsage.toJSONAttributeUsage)(this.usage),
        data: _utils.JSONHelper.writeECPoint(this.value)
      };
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { reader } = options;
      const { usage } = (0, _get3.default)(ECPointAttribute.__proto__ || (0, _getPrototypeOf2.default)(ECPointAttribute), 'deserializeAttributeWireBase', this).call(this, options);
      if (!(usage === 0x02 || usage === 0x03)) {
        throw new _errors.InvalidFormatError();
      }
      const value = _common2.default.bufferToECPoint(Buffer.concat([Buffer.from([usage]), reader.readBytes(32)]));
      return new this({ usage, value });
    }
  }]);
  return ECPointAttribute;
}(_AttributeBase3.default);

exports.default = ECPointAttribute;