'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _AttributeBase2 = require('./AttributeBase');

var _AttributeBase3 = _interopRequireDefault(_AttributeBase2);

require('../../Serializable');

var _errors = require('../../errors');

var _AttributeUsage = require('./AttributeUsage');

var _common = require('../../common');

var _common2 = _interopRequireDefault(_common);

var _utils = require('../../utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let UInt160Attribute = function (_AttributeBase) {
  (0, _inherits3.default)(UInt160Attribute, _AttributeBase);

  function UInt160Attribute({ usage, value }) {
    (0, _classCallCheck3.default)(this, UInt160Attribute);

    var _this = (0, _possibleConstructorReturn3.default)(this, (UInt160Attribute.__proto__ || (0, _getPrototypeOf2.default)(UInt160Attribute)).call(this));

    _this.equals = _utils2.default.equals(UInt160Attribute, other => _this.usage === other.usage && _common2.default.uInt160Equal(_this.value, other.value));

    _this.usage = usage;
    _this.value = value;
    _this.size = _utils.IOHelper.sizeOfUInt8 + _utils.IOHelper.sizeOfUInt160;
    return _this;
  }

  (0, _createClass3.default)(UInt160Attribute, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      (0, _get3.default)(UInt160Attribute.prototype.__proto__ || (0, _getPrototypeOf2.default)(UInt160Attribute.prototype), 'serializeWireBase', this).call(this, writer);
      writer.writeUInt160(this.value);
    }

    // eslint-disable-next-line

  }, {
    key: 'serializeJSON',


    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        usage: (0, _AttributeUsage.toJSONAttributeUsage)(this.usage),
        data: _utils.JSONHelper.writeUInt160(this.value)
      };
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { reader } = options;
      const { usage } = (0, _get3.default)(UInt160Attribute.__proto__ || (0, _getPrototypeOf2.default)(UInt160Attribute), 'deserializeAttributeWireBase', this).call(this, options);
      if (usage !== 0x20) {
        throw new _errors.InvalidFormatError();
      }
      const value = reader.readUInt160();
      return new this({ usage, value });
    }
  }]);
  return UInt160Attribute;
}(_AttributeBase3.default);

exports.default = UInt160Attribute;