'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _bn = require('bn.js');

var _bn2 = _interopRequireDefault(_bn);

var _bignumber = require('bignumber.js');

var _bignumber2 = _interopRequireDefault(_bignumber);

var _common = require('../common');

var _common2 = _interopRequireDefault(_common);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  writeUInt64LE: value => value.toString(16, 16),
  readUInt64LE: value => new _bn2.default(value, 16),
  writeUInt160: value => _common2.default.uInt160ToString(value),
  readUInt160: hash => _common2.default.stringToUInt160(hash),
  writeUInt256: value => _common2.default.uInt256ToString(value),
  readUInt256: hash => _common2.default.stringToUInt256(hash),
  writeFixed8: value => _common2.default.fixed8ToDecimal(value).toString(),
  readFixed8: value => _common2.default.fixed8FromDecimal(new _bignumber2.default(value)),
  writeECPoint: value => _common2.default.ecPointToString(value),
  readECPoint: value => _common2.default.stringToECPoint(value),
  writeBuffer: value => value.toString('hex'),
  readBuffer: value => Buffer.from(value, 'hex')
};