'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _async = require('async');

var _async2 = _interopRequireDefault(_async);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const promisify = func => (...args) => new _promise2.default((resolve, reject) => func(...args, (error, result) => {
  if (error != null) {
    reject(error);
  } else {
    resolve(result);
  }
}));
// TODO: Should just eliminate this to keep package size down


const promisifiedSome = promisify(_async2.default.some);

function some(values, func) {
  return promisifiedSome(values, _async2.default.asyncify(func));
}

exports.default = {
  some
};